'From Squeak3.0 of 4 February 2001 [latest update: #3545] on 23 November 2001 at 2:01:42 am'!
Object subclass: #VWXMLXMLParser
	instanceVariableNames: 'sourceStack hereChar lastSource currentSource documentNode dtd unresolvedIDREFs builder validating ignore eol isEncodeChecking '
	classVariableNames: 'IllegalCharacters '
	poolDictionaries: ''
	category: 'XML-Parsing'!

!VWXMLElement methodsFor: 'accessing' stamp: 'MU 11/7/2000 13:38'!
attributeNamed: attributeName	
	"##add MU 11/7/2000 13:38"
	^(self attributes
		detect: [:a | a tag isLike: attributeName]
		ifNone: []) ! !

!VWXMLElement methodsFor: 'accessing' stamp: 'MU 10/31/2000 22:53'!
childNodes
	"##add -umejava"
	^self elements select:[:each | each isElement]! !

!VWXMLElement methodsFor: 'accessing' stamp: 'MU 11/22/2000 21:45'!
elementsWithoutTexts
	"##add -umejava"
	^self elements select: [:e | e isText not].! !

!VWXMLElement methodsFor: 'modifying' stamp: 'MU 11/7/2000 14:34'!
removeAllNodes
	"##add -umejava"
	self childNodes copy do: [:each | self removeNode: each].! !

!VWXMLElement methodsFor: 'modifying' stamp: 'MU 10/31/2000 22:50'!
removeNode: aNode
	"##add -umejava"
	elements == nil
		ifTrue: [elements := OrderedCollection new]
		ifFalse: [elements class == Array
			ifTrue: [elements := elements asOrderedCollection]].
	elements remove: aNode! !


!VWXMLXMLParser methodsFor: 'private' stamp: 'mune 11/27/2000 15:39'!
malformed: aString

	self isEncodeChecking ifTrue:[ self class malformed: aString]! !

!VWXMLXMLParser methodsFor: 'private' stamp: 'mune 11/27/2000 15:40'!
validateEncoding: encName

	| c |
	self isEncodeChecking ifTrue:[
	encName size = 0 ifTrue: [self expected: 'non-empty encoding name'].
	c := encName first.
	(c asInteger < 128 and: [c isLetter])
		ifFalse: [self malformed: ('The first letter of the encoding ("<1s>") must be an ASCII alphabetic letter'
						expandMacrosWith: encName)].
	2 to: encName size do: [:i |
		c := encName at: i.
		(c asInteger < 128 and: [c isLetter or: [c isDigit or: [#($. $_ $-) includes: c]]]) "##changed!!"
			ifFalse: [self malformed: ('The first name of the encoding ("<1s>") must be ''.'', ''_'', ''-'', or an ASCII letter or digit'
						expandMacrosWith: encName)]]]! !

!VWXMLXMLParser methodsFor: 'accessing' stamp: 'mune 11/27/2000 15:38'!
isEncodeChecking
	isEncodeChecking isNil ifTrue:[isEncodeChecking := true].
	^isEncodeChecking! !

!VWXMLXMLParser methodsFor: 'accessing' stamp: 'mune 11/27/2000 15:53'!
isEncodeChecking: aBoolean
	isEncodeChecking := aBoolean! !


!VWXMLXMLParser class methodsFor: 'instance creation' stamp: 'mune 11/27/2000 15:53'!
parse: aString
	"##add -umejava"
	^self processDocumentString: aString beforeScanDo: [:p | p isEncodeChecking: false. p validate: false.]! !

