'From Squeak3.0 of 4 February 2001 [latest update: #3545] on 23 November 2001 at 2:02:44 am'!
Object variableSubclass: #VWXMLPseudoCharacterTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'XML-Parsing'!

!VWXMLPseudoCharacterTable methodsFor: 'accessing'!
at: index 
	(index >= 1
			and: [index <= 32])
		ifTrue: [index == 10
				ifTrue: [^ 0]
				ifFalse: [index == 11
						ifTrue: [^ 0]
						ifFalse: [index == 14
								ifTrue: [^ 0]
								ifFalse: [^ 1]]]]
		ifFalse: [(index >= 55297
					and: [index <= 57344])
				ifTrue: [^ 1]
				ifFalse: [(index >= 65535
							and: [index <= 65536])
						ifTrue: [^ 1]
						ifFalse: [(index <= 0
									or: [index > 65536])
								ifTrue: [self error: 'subscript is out of bounds: ' , index printString.
									^ -1]
								ifFalse: [^ 0]]]].
	^ 0! !

!VWXMLPseudoCharacterTable methodsFor: 'accessing'!
at: index put: value 
	^ self shouldNotImplement! !


!VWXMLXMLParser class methodsFor: 'class initialization' stamp: 'MU 11/19/2001 17:23'!
initialize
	"VWXMLXMLParser initialize"

	IllegalCharacters := VWXMLPseudoCharacterTable new.
	"Slow, but drastically reduces image size"
	
	"IllegalCharacters := WordArray new: 16r110000.

	((0 to: 16r1F) asSet remove: 9; remove: 10; remove: 13; yourself)
		do: [:i | IllegalCharacters at: i+1 put: 1].
	16rD800 to: 16rDFFF
		do: [:i | IllegalCharacters at: i+1 put: 1].
	16rFFFE to: 16rFFFF
		do: [:i | IllegalCharacters at: i+1 put: 1]."
	"IllegalCharacters compress."! !

VWXMLXMLParser initialize!
